#!/usr/bin/python2.7
#lesen_sig_bytes.py

#Wesentliche Hinweise zur ISP-Programmierung
#von Atmel-Controllern finden sich neben 
#den Angaben in den Datenblaettern der betreffenden #Mikrocontroller u. a. in inzwischen vergriffenen #Fachbuechern von W.Trampert sowie B.Kainka (vgl Literaturangaben zum Beitrag).

#H. Nieder, Fruehjahr 2015
#aktualisierte Version vom Januar 2016

import sys
import time
import RPi.GPIO as GPIO

#GPIO-Pins
MOSI=8
SCK =7
MISO=25
RES=23
#Test-GPIO, fuer Erweiterungen
STR=24
#GPIO-Festlegungen
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)

GPIO.setup(MOSI,GPIO.OUT)
GPIO.setup(SCK,GPIO.OUT)
GPIO.setup(STR,GPIO.OUT)
GPIO.setup(RES,GPIO.OUT)
GPIO.setup(MISO,GPIO.IN)

out=GPIO.output
inp=GPIO.input
low=GPIO.LOW
hi=GPIO.HIGH

#Anfangszustand
out(STR,hi)
out(RES,low)
Byte=0

z=0

def pulse_STR():
    out(STR,low)
    time.sleep(0.01)
    out(STR,hi)


def ByteToHex(Byte):
    Lo=0
    Hi=0
    
    Dat=Byte
    
    Hi=Dat/16
    Lo=Dat%16
    if Hi>9:
        Hi=Hi+7;
    HiHex=chr(48+Hi)
    
    if Lo>9:
        Lo=Lo+7
    LoHex=chr(48+Lo)
    
    ByteHex=HiHex+LoHex
    
    return ByteHex


Byte_in=0

def SPI_ein():
    out(SCK,hi)
    Byte_in=0
    Bit7=128
    n=0
    for n in range(0,8):
             
        out(SCK,low)
        time.sleep(0.0001)
        if (GPIO.input(MISO)):
            Byte_in=Byte_in+Bit7 
               
        time.sleep(0.0001)
        out(SCK,hi)
        time.sleep(0.0001)
                
        Bit7=Bit7>>1#1 Bit nach rechts schieben
        
    time.sleep(0.0001)
    Ergebnis=Byte_in
    Zahl=ByteToHex(Byte_in)
    print Zahl,
    pulse_STR()#kann hier entfallen


def SPI_aus(Byte):
    Byte=255-Byte 
    Bit7_wt=128
    n=0
    for n in range(0,8):
        if (Byte & Bit7_wt) >0:
            out(MOSI,hi)      
        else:
            out(MOSI,low)
        time.sleep(0.00002)
        out(SCK,low)
        Bit7_wt=Bit7_wt>>1#1 Bit nach rechts schieben
        
        time.sleep(0.00002)
        out(SCK,hi)
    
    out(MOSI,hi)
    time.sleep(0.01)
    #pulse_STR()#kann entfallen

def HexToInt(Hexzahl):
    H=0
    L=0
    Hnib=Hexzahl[0:1]
   
    H= ord(Hnib)-48
    
    if H>9:
        H=H-7
    Lnib=Hexzahl[1:2]
    
    L= ord(Lnib)-48
        
    if L>9:
        L=L-7
    Ergebnis=16*H+L
    Byte=Ergebnis
    return Byte

def prog_en():
    SPI_aus(0xAC)
    SPI_aus(0x53)
    SPI_aus(0)
    SPI_aus(0)    


def read_sig_byte(Byte):
    SPI_aus(0x30)
    SPI_aus(0x00)
    SPI_aus(Byte)
    SPI_ein()


#Start
out(RES,hi)#Reset "einschalten"

time.sleep(0.02)

prog_en()
n=0
#ad=0
print 
print "Signature Bytes lesen: ",

for ad in range(0,3):
    read_sig_byte(ad)

print

time.sleep(1)

out(RES,low)
print
print "Programmende"







